function [etamat] = averaging(xnodes,Q,nelem,LM)

S = zeros(nelem+1,nelem+1);
for e=1:1:nelem,
    x1 = xnodes(e);
    x2 = xnodes(e+1);
    syms x z
    k_x = 1/100 + 100*(x-0.36388)^2;    %k(x)
    k_z = subs(k_x,x,z*(x2-x1)/2 + (x1+x2)/2);
    
    zintegrand11 = k_z*(x2-x1)/8*(1-z)^2;
    integrand11 = vectorize(inline(char(zintegrand11)));
    s11 = quad(integrand11,-1,1);

    zintegrand22 = k_z*(x2-x1)/8*(1+z)^2;
    integrand22 = vectorize(inline(char(zintegrand22)));
    s22 = quad(integrand22,-1,1);

    zintegrand12 = k_z*(x2-x1)/8*(1-z^2);
    integrand12 = vectorize(inline(char(zintegrand12)));
    s12 = quad(integrand12,-1,1);

    se = [s11, s12; s12, s22];
    
    S(LM(1,e),LM(1,e)) = S(LM(1,e),LM(1,e)) + se(1,1);%    
    S(LM(1,e),LM(2,e)) = S(LM(1,e),LM(2,e)) + se(1,2);%Element contribution to 
    S(LM(2,e),LM(1,e)) = S(LM(2,e),LM(1,e)) + se(2,1);%Global S Matrix
    S(LM(2,e),LM(2,e)) = S(LM(2,e),LM(2,e)) + se(2,2);%
end
S;
Du_h = zeros(nelem+1,1);    %to hold slope calculated from FE solution
for e=1:1:nelem,
    x1 = xnodes(e);
    x2 = xnodes(e+1);
    syms x z
    k_x = 1/100 + 100*(x-0.36388)^2;    %k(x)
    k_z = subs(k_x,x,z*(x2-x1)/2 + (x1+x2)/2);
    
    zintegrand1 = (Q(e+1)-Q(e))*k_z*(1-z)/2*1/2;
    integrand1 = vectorize(inline(char(zintegrand1)));
    d_u_h1 = quad(integrand1,-1,1);
    
    zintegrand2 = (Q(e+1)-Q(e))*k_z*(1+z)/2*1/2;
    integrand2 = vectorize(inline(char(zintegrand2)));
    d_u_h2 = quad(integrand2,-1,1);
    
    Du_h_e = [d_u_h1; d_u_h2];
    
    Du_h(LM(1,e)) = Du_h(LM(1,e)) + Du_h_e(1);
    Du_h(LM(2,e)) = Du_h(LM(2,e)) + Du_h_e(2);
end
Du_h;
du_est = S\Du_h;    %calculating nodal values of the continuous function
subplot(212), plot(xnodes,du_est,'r'), title('diff(u_h,x)');
hold on
%***************************Now calculating the estimators******************************%
etamat = zeros(nelem,1);
for i=1:1:nelem,
    x1 = xnodes(i);
    x2 = xnodes(i+1);
    syms x z
    k_x = 1/100 + 100*(x-0.36388)^2;    %k(x)
        
    xintegrand = k_x*((x-x1)*(du_est(e+1)-du_est(e))/(x2-x1)+du_est(e)-(Q(e+1)-Q(e))/(x2-x1))^2*(x2-x1);
    zintegrand = subs(xintegrand,x,z*(x2-x1)/2 + (x1+x2)/2);
    integrand = vectorize(inline(char(zintegrand)));
    etamat(i) = sqrt(quad(integrand,-1,1));
end    
