%Computing the element load vector

function [fe] = elemload1D(ch,x1,x2)

syms x z
f_x = 2*(1 + 100*(x-0.36388)*(atan(100*(x-0.36388)) + atan(100*0.36388)));

xintegrand1 = f_x*(x2-x)/2;
zintegrand1 = subs(xintegrand1,x,z*(x2-x1)/2+(x1+x2)/2);
zinteg1in = inline(char(zintegrand1));
integrand1 = vectorize(inline(char(zintegrand1)));

xintegrand2 = f_x*(x-x1)/2;
zintegrand2 = subs(xintegrand2,x,z*(x2-x1)/2+(x1+x2)/2);
zinteg2in = inline(char(zintegrand2));
integrand2 = vectorize(inline(char(zintegrand2)));

if ch==0,
    f1 = quad(integrand1,-1,1);
    f2 = quad(integrand2,-1,1); 
end

if ch==1,
    f1 = 2*zinteg1in(0);
    f2 = 2*zinteg2in(0);
end  

if ch==2,
    f1 = zinteg1in(-1/sqrt(3)) + zinteg1in(1/sqrt(3));
    f2 = zinteg2in(-1/sqrt(3)) + zinteg2in(1/sqrt(3));
end  

fe =  [f1 ; f2];
