%Computing the element stiffness matrix

function [ke] = elemstiff1D(ch,x1, x2)

he = x2 - x1;

syms x z
k_x = 1/100 + 100*(x-0.36388)^2;    %k(x)
k_z = subs(k_x,x,z*(x2-x1)/2 + (x1+x2)/2);
kzin = inline(char(k_z));
k_zin = vectorize(inline(char(k_z)));
if ch==0,
    kij = quad(k_zin,-1,1); 
end

if ch==1,
    kij = 2*kzin(0);
end  

if ch==2,
    kij = kzin(-1/sqrt(3)) + kzin(1/sqrt(3));
end

ke = 0.5/he * [kij -kij; -kij kij];