%Computing the vector of the estimates (explicit residual)
function [etamat] = estimator(xnodes,Q,nelem)
syms x z
k_x = 1/100 + 100*(x-0.36388)^2;    %k(x)
f_x = 2*(1 + 100*(x-0.36388)*(atan(100*(x-0.36388)) + atan(100*0.36388)));

for i=1:1:nelem,
    x1 = xnodes(i);
    x2 = xnodes(i+1);    
    h_i = x2 - x1;
    du_h = (Q(i+1) - Q(i))/h_i;
    term2 = diff(k_x*du_h,'x');
    S_x = (f_x + term2)^2;
    S_z = subs(S_x,x,z*(x2-x1)/2 + (x1+x2)/2);

    k_z = subs(k_x,x,z*(x2-x1)/2 + (x1+x2)/2);
    k_zin = inline(char(k_z));
    zintegrand = h_i^3/(2*k_zin(0))*S_z;
    integrandin = inline(char(zintegrand));
    integrand = vectorize(inline(char(zintegrand)));

    etamat(i) = sqrt(quad(integrand,-1,1));
   
end    